var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.launchTizenSimulator=launchTizenSimulator;exports.configureTizenGlobal=exports.buildTizenProject=exports.runTizen=exports.addDevelopTizenCertificate=exports.createDevelopTizenCertificate=exports.configureTizenProject=exports.copyTizenAssets=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _path=_interopRequireDefault(require("path"));var _fs=_interopRequireDefault(require("fs"));var _chalk=_interopRequireDefault(require("chalk"));var _exec=require("../systemTools/exec");var _common=require("../common");var _fileutils=require("../systemTools/fileutils");var _web=require("./web");var configureTizenGlobal=function configureTizenGlobal(c){return new Promise(function(resolve,reject){(0,_common.logTask)('configureTizenGlobal');var tizenAuthorCert=_path.default.join(c.paths.globalConfigFolder,'tizen_author.p12');if(_fs.default.existsSync(tizenAuthorCert)){console.log('tizen_author.p12 file exists!');resolve();}else{console.log('tizen_author.p12 file missing! Creating one for you...');createDevelopTizenCertificate(c).then(function(){return resolve();}).catch(function(e){return reject(e);});}});};exports.configureTizenGlobal=configureTizenGlobal;function launchTizenSimulator(c,name){(0,_common.logTask)("launchTizenSimulator:"+name);if(name){return(0,_exec.execCLI)(c,_common.CLI_TIZEN_EMULATOR,"launch --name "+name);}return Promise.reject('No simulator -t target name specified!');}var copyTizenAssets=function copyTizenAssets(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('copyTizenAssets');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;var sourcePath=_path.default.join(c.paths.appConfigFolder,'assets',platform);var destPath=_path.default.join((0,_common.getAppFolder)(c,platform));(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath,destPath);resolve();});};exports.copyTizenAssets=copyTizenAssets;var createDevelopTizenCertificate=function createDevelopTizenCertificate(c){return new Promise(function(resolve,reject){(0,_common.logTask)('createDevelopTizenCertificate');(0,_exec.execCLI)(c,_common.CLI_TIZEN,"certificate -- "+c.paths.globalConfigFolder+" -a rnv -f tizen_author -p 1234").then(function(){return addDevelopTizenCertificate(c);}).then(function(){return resolve();}).catch(function(e){(0,_common.logError)(e);resolve();});});};exports.createDevelopTizenCertificate=createDevelopTizenCertificate;var addDevelopTizenCertificate=function addDevelopTizenCertificate(c){return new Promise(function(resolve){(0,_common.logTask)('addDevelopTizenCertificate');(0,_exec.execCLI)(c,_common.CLI_TIZEN,"security-profiles add -n RNVanillaCert -a "+_path.default.join(c.paths.globalConfigFolder,'tizen_author.p12')+" -p 1234").then(function(){return resolve();}).catch(function(e){(0,_common.logError)(e);resolve();});});};exports.addDevelopTizenCertificate=addDevelopTizenCertificate;var getDeviceID=function getDeviceID(c,target){var device,connectResponse,devicesList,lines,devices,deviceID;return _regenerator.default.async(function getDeviceID$(_context){while(1){switch(_context.prev=_context.next){case 0:device=c.program.device;if(!device){_context.next=7;break;}_context.next=4;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_SDB_TIZEN,"connect "+target,_common.logTask));case 4:connectResponse=_context.sent;if(!connectResponse.includes('failed to connect to remote target')){_context.next=7;break;}throw new Error(connectResponse);case 7:_context.next=9;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_SDB_TIZEN,'devices',_common.logTask));case 9:devicesList=_context.sent;if(!devicesList.includes(target)){_context.next=16;break;}lines=devicesList.trim().split(/\r?\n/);devices=lines.filter(function(line){return line.includes(target);});if(devices.length>1){}deviceID=devices[0].split('device')[1].trim();return _context.abrupt("return",deviceID);case 16:throw"No device matching "+target+" could be found.";case 17:case"end":return _context.stop();}}});};var runTizen=function runTizen(c,platform,target){var platformConfig,tDir,tOut,tBuild,tId,gwt,certProfile,deviceID,hasDevice;return _regenerator.default.async(function runTizen$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:(0,_common.logTask)("runTizen:"+platform+":"+target);platformConfig=c.files.appConfigFile.platforms[platform];tDir=(0,_common.getAppFolder)(c,platform);tOut=_path.default.join(tDir,'output');tBuild=_path.default.join(tDir,'build');tId=platformConfig.id;gwt=platformConfig.appName+".wgt";certProfile=platformConfig.certificateProfile;_context2.prev=8;_context2.next=11;return _regenerator.default.awrap(getDeviceID(c,target));case 11:deviceID=_context2.sent;_context2.next=21;break;case 14:_context2.prev=14;_context2.t0=_context2["catch"](8);if(!(_context2.t0&&_context2.t0.includes&&_context2.t0.includes("No device matching "+target+" could be found"))){_context2.next=21;break;}_context2.next=19;return _regenerator.default.awrap(launchTizenSimulator(c,target));case 19:(0,_common.logInfo)("Once simulator is ready run: \""+_chalk.default.white.bold("rnv run -p "+platform+" -t "+target)+"\" again");return _context2.abrupt("return",true);case 21:if(deviceID){_context2.next=23;break;}throw new Error('no deviceid');case 23:hasDevice=false;_context2.next=26;return _regenerator.default.awrap(configureTizenProject(c,platform));case 26:_context2.next=28;return _regenerator.default.awrap((0,_web.buildWeb)(c,platform));case 28:_context2.next=30;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_TIZEN,"build-web -- "+tDir+" -out "+tBuild,_common.logTask));case 30:_context2.next=32;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_TIZEN,"package -- "+tBuild+" -s "+certProfile+" -t wgt -o "+tOut,_common.logTask));case 32:_context2.prev=32;_context2.next=35;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_TIZEN,"uninstall -p "+tId+" -t "+deviceID,_common.logTask));case 35:hasDevice=true;_context2.next=44;break;case 38:_context2.prev=38;_context2.t1=_context2["catch"](32);if(!(_context2.t1&&_context2.t1.includes&&_context2.t1.includes('No device matching'))){_context2.next=44;break;}_context2.next=43;return _regenerator.default.awrap(launchTizenSimulator(c,target));case 43:(0,_common.logInfo)("Once simulator is ready run: \""+_chalk.default.white.bold("rnv run -p "+platform+" -t "+target)+"\" again");case 44:_context2.prev=44;_context2.next=47;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_TIZEN,"install -- "+tOut+" -n "+gwt+" -t "+deviceID,_common.logTask));case 47:hasDevice=true;_context2.next=57;break;case 50:_context2.prev=50;_context2.t2=_context2["catch"](44);(0,_common.logError)(_context2.t2);(0,_common.logWarning)("Looks like there is no emulator or device connected! Let's try to launch it. \""+_chalk.default.white.bold("rnv target launch -p "+platform+" -t "+target)+"\"");_context2.next=56;return _regenerator.default.awrap(launchTizenSimulator(c,target));case 56:(0,_common.logInfo)("Once simulator is ready run: \""+_chalk.default.white.bold("rnv run -p "+platform+" -t "+target)+"\" again");case 57:if(!(platform!=='tizenwatch'&&hasDevice)){_context2.next=62;break;}_context2.next=60;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_TIZEN,"run -p "+tId+" -t "+deviceID,_common.logTask));case 60:_context2.next=63;break;case 62:if(platform==='tizenwatch'&&hasDevice){(0,_common.logInfo)('App installed. Please start it manually');}case 63:return _context2.abrupt("return",true);case 64:case"end":return _context2.stop();}}},null,null,[[8,14],[32,38],[44,50]]);};exports.runTizen=runTizen;var buildTizenProject=function buildTizenProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("buildTizenProject:"+platform);var platformConfig=c.files.appConfigFile.platforms[platform];var tDir=(0,_common.getAppFolder)(c,platform);var tOut=_path.default.join(tDir,'output');var tBuild=_path.default.join(tDir,'build');var certProfile=platformConfig.certificateProfile;configureTizenProject(c,platform).then(function(){return(0,_web.buildWeb)(c,platform);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"build-web -- "+tDir+" -out "+tBuild,_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"package -- "+tBuild+" -s "+certProfile+" -t wgt -o "+tOut,_common.logTask);}).then(function(){(0,_common.logSuccess)("Your GWT package is located in "+_chalk.default.white(tOut)+".");return resolve();}).catch(function(e){return reject(e);});});};exports.buildTizenProject=buildTizenProject;var configureTizenProject=function configureTizenProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('configureTizenProject');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;copyTizenAssets(c,platform).then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).then(function(){return configureProject(c,platform);}).then(function(){return resolve();}).catch(function(e){return reject(e);});});};exports.configureTizenProject=configureTizenProject;var configureProject=function configureProject(c,platform){return new Promise(function(resolve){(0,_common.logTask)("configureProject:"+platform);var appFolder=(0,_common.getAppFolder)(c,platform);var configFile='config.xml';var p=c.files.appConfigFile.platforms[platform];(0,_common.writeCleanFile)(_path.default.join((0,_common.getAppTemplateFolder)(c,platform),configFile),_path.default.join(appFolder,configFile),[{pattern:'{{PACKAGE}}',override:p.package},{pattern:'{{ID}}',override:p.id},{pattern:'{{APP_NAME}}',override:p.appName}]);resolve();});};