var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.checkIfTemplateInstalled=exports.applyTemplate=exports.getTemplateOptions=exports.addTemplate=exports.listTemplates=void 0;var _chalk=_interopRequireDefault(require("chalk"));var _fs=_interopRequireDefault(require("fs"));var _path=_interopRequireDefault(require("path"));var _exec=require("../systemTools/exec");var _fileutils=require("../systemTools/fileutils");var _common=require("../common");var _pluginTools=require("../pluginTools");var DEFAULT_TEMPLATES=['renative-template-hello-world','renative-template-blank'];var listTemplates=function listTemplates(c){return new Promise(function(resolve,reject){(0,_common.logTask)('listTemplates');opts=(0,_common.generateOptions)(DEFAULT_TEMPLATES);console.log(opts.asString);resolve();});};exports.listTemplates=listTemplates;var addTemplate=function addTemplate(c){return new Promise(function(resolve,reject){(0,_common.logTask)('addTemplate');(0,_exec.executeAsync)('npm',['install','renative-template-hello-world','--save-dev']).then(function(){resolve();}).catch(function(error){return(0,_common.logError)(error);});});};exports.addTemplate=addTemplate;var checkIfTemplateInstalled=function checkIfTemplateInstalled(c){return new Promise(function(resolve,reject){(0,_common.logTask)('checkIfTemplateInstalled');if(!c.files.projectConfig.defaultProjectConfigs){(0,_common.logWarning)("Your "+_chalk.default.white(c.paths.projectConfigPath)+" does not contain "+_chalk.default.white('defaultProjectConfigs')+" object. ReNative will skip template generation");resolve();return;}var templateName=c.files.projectConfig.defaultProjectConfigs.template;if(!templateName){templateName='renative-template-hello-world';(0,_common.logWarning)("You're missing template name in your "+_chalk.default.white(c.paths.projectConfigPath)+". ReNative will add default "+_chalk.default.white(templateName)+" for you");if(!c.files.projectConfig.defaultProjectConfigs)c.files.projectConfig.defaultProjectConfigs={};c.files.projectConfig.defaultProjectConfigs.template=templateName;_fs.default.writeFileSync(c.paths.projectConfigPath,JSON.stringify(c.files.projectConfig,null,2));}c.paths.templateFolder=_path.default.join(c.paths.projectNodeModulesFolder,templateName);if(!_fs.default.existsSync(c.paths.templateFolder)){(0,_common.logWarning)("Your "+_chalk.default.white(c.paths.templateFolder)+" template is not installed. ReNative will install it for you");if(c.files.projectPackage.devDependencies){if(!c.files.projectPackage.devDependencies[templateName]){c.files.projectPackage.devDependencies[templateName]='latest';(0,_fileutils.writeObjectSync)(c.paths.projectPackagePath,c.files.projectPackage);}}c._requiresNpmInstall=true;}resolve();});};exports.checkIfTemplateInstalled=checkIfTemplateInstalled;var applyTemplate=function applyTemplate(c,selectedTemplate){return new Promise(function(resolve,reject){if(selectedTemplate){(0,_common.logTask)("applyTemplate:"+selectedTemplate);resolve();return;}if(!c.files.projectConfig.defaultProjectConfigs){(0,_common.logTask)('applyTemplate');resolve();return;}(0,_common.logTask)("applyTemplate:"+c.files.projectConfig.defaultProjectConfigs.template);var templateFolder=_path.default.join(c.paths.projectNodeModulesFolder,c.files.projectConfig.defaultProjectConfigs.template);if(!_fs.default.existsSync(templateFolder)){(0,_common.logWarning)("Template "+_chalk.default.white(c.files.projectConfig.defaultProjectConfigs.template)+" does not exist in your ./node_modules. skipping");resolve();return;}var templateAppConfigsFolder=_path.default.join(templateFolder,'appConfigs');var templateAppConfigFolder=_fs.default.readdirSync(templateAppConfigsFolder)[0];var templateProjectConfigFolder=_path.default.join(templateFolder,'projectConfig');if(templateAppConfigFolder)c.defaultAppConfigId=templateAppConfigFolder;(0,_common.logTask)('configureProject:check src');if(!_fs.default.existsSync(c.paths.projectSourceFolder)){(0,_common.logWarning)("Looks like your src folder "+_chalk.default.white(c.paths.projectSourceFolder)+" is missing! Let's create one for you.");(0,_fileutils.copyFolderContentsRecursiveSync)(_path.default.join(templateFolder,'src'),c.paths.projectSourceFolder);}(0,_common.logTask)('configureProject:check appConfigs');(0,_common.setAppConfig)(c,_path.default.join(c.paths.appConfigsFolder,c.defaultAppConfigId));if(!_fs.default.existsSync(c.paths.appConfigsFolder)){(0,_common.logWarning)("Looks like your appConfig folder "+_chalk.default.white(c.paths.appConfigsFolder)+" is missing! Let's create sample config for you.");(0,_fileutils.copyFolderContentsRecursiveSync)(templateAppConfigsFolder,c.paths.appConfigsFolder);try{var appConfig=JSON.parse(_fs.default.readFileSync(c.paths.appConfigPath).toString());appConfig.common.title=c.defaultProjectConfigs.defaultTitle||c.files.projectPackage.title;appConfig.common.id=c.defaultProjectConfigs.defaultAppId||c.files.projectPackage.defaultAppId;appConfig.id=c.defaultProjectConfigs.defaultAppConfigId||c.defaultAppConfigId;appConfig.platforms.ios.teamID='';appConfig.platforms.tvos.teamID='';var supPlats=c.defaultProjectConfigs.supportedPlatforms||c.files.projectPackage.supportedPlatforms;if(supPlats){for(var pk in appConfig.platforms){if(!supPlats.includes(pk)){delete appConfig.platforms[pk];}}}_fs.default.writeFileSync(c.paths.appConfigPath,JSON.stringify(appConfig,null,2));}catch(e){(0,_common.logError)(e);}}(0,_common.logTask)('configureProject:check projectConfigs');if(!_fs.default.existsSync(c.paths.projectConfigFolder)){(0,_common.logWarning)("Looks like your projectConfig folder "+_chalk.default.white(c.paths.projectConfigFolder)+" is missing! Let's create one for you.");(0,_fileutils.copyFolderContentsRecursiveSync)(templateProjectConfigFolder,c.paths.projectConfigFolder);}resolve();});};exports.applyTemplate=applyTemplate;var getTemplateOptions=function getTemplateOptions(){return(0,_common.generateOptions)(DEFAULT_TEMPLATES);};exports.getTemplateOptions=getTemplateOptions;